由于我太菜了,不会矩阵乘法,所以给同样不会矩阵乘法同学的福利

首先发现这题点很多边很少,实际上有用的点 \(<= 2 * T\)(因为每条边会触及两个点嘛)

所以我们可以把点的范围缩到 \(2 * T\)来,然后...

算法1 Bellman - Ford O(NT)

什么,限制边数?那不就是可爱的 \(BellmanFord\)吗?

看看复杂度,嗯嗯 \(10 ^ 8\) 海星,常数超小的我肯定不用吸氧的

#pragma GCC optimize(2)
#include <cstdio>
#include <iostream>
#include <algorithm>
#include <cmath>
#include <cstring>
using namespace std;
const int N = 205, M = 105;
struct Edge{
int u, v, w;
}e[M];
int m, n, s, t, adj[N], dis[N], bDis[N], tot;
void inline read(int &x) {
x = 0;
char s = getchar();
while(s > '9' || s < '0') s = getchar();
while(s <= '9' && s >= '0') x = x * 10 + s - '0', s = getchar();
}
int inline get(int &x) {
return lower_bound(adj + 1, adj + 1 + tot, x) - adj;
} int inline bellmanFord(){
memset(dis, 0x3f, sizeof dis);
dis[s] = 0;
for(register int i = 1; i <= n; i++){
memcpy(bDis, dis, sizeof dis);
memset(dis, 0x3f, sizeof dis);
for(register int j = 1; j <= m; j++){
dis[e[j].v] = min(dis[e[j].v], bDis[e[j].u] + e[j].w);
dis[e[j].u] = min(dis[e[j].u], bDis[e[j].v] + e[j].w);
}
}
return dis[t];
} int main(){
read(n); read(m); read(s); read(t);
for (register int i = 1; i <= m; i++) {
read(e[i].w); read(e[i].u); read(e[i].v);
adj[++tot] = e[i].u;
adj[++tot] = e[i].v;
}
sort(adj + 1, adj + 1 + tot);
tot = unique(adj + 1, adj + 1 + tot) - adj - 1;
for (register int i = 1; i <= m; i++) {
e[i].u = get(e[i].u), e[i].v = get(e[i].v);
}
s = get(s), t = get(t);
printf("%d\n", bellmanFord());
return 0;
}

真香

算法2 倍增 + Floyd O(T ^ 3 * log_2N)

据说这题正解要用矩阵乘法,可我不会,咋办呢?

不如用倍增的思想,把\(N\)拆成二进制下的多个\(1\),我们把每个\('1'\)最短路搞出来,然后拼出来最终的最短路,先预处理:

\(d[i][j][l]\) 表示从 \(i\) 到 \(j\) 恰好经过 \(2 ^ l\) 条边的最短路。

初始化 \(d[i][j][0] = w[i][j]\),剩下为正无穷(注意是恰好 \(N\) 条边,所以 \(d[i][i][0]\) 也是非法状态)

转移也很好想:

\(d[i][j][l] = min(d[i][k][l - 1] + d[k][j][l - 1])\),对于一个状态 \(d[i][j][l]\),枚举中间点 \(k\) 即可,所以预处理复杂度 \(O(T ^ 3 * log_2N)\)

接下来用二进制拼起来就行辣~,设 \(g[i]\) 为这前几部走完后,从 \(s\) 到 \(i\) 的最短路, \(f[i]\) 为当前到 \(i\) 的最短路,与保卫王国的拼凑法思想差不多,即:

\(f[i] = min(g[j] + d[j][i][c])\) 若 \(N\) 的二进制第 \(c\) 位为 \(1\)。

#include <cstdio>
#include <iostream>
#include <algorithm>
#include <cmath>
#include <cstring>
using namespace std;
const int N = 205, M = 105;
struct Edge{
int u, v, w;
}e[M];
int m, n, s, t, adj[N], tot, d[N][N][20], f[N], g[N];
int L; int inline get(int x) {
return lower_bound(adj + 1, adj + 1 + tot, x) - adj;
}
int main(){
memset(d, 0x3f, sizeof d);
scanf("%d%d%d%d", &n, &m, &s, &t);
L = log2(n);
for (int i = 1; i <= m; i++) {
scanf("%d%d%d", &e[i].w, &e[i].u, &e[i].v);
adj[++tot] = e[i].u;
adj[++tot] = e[i].v;
}
sort(adj + 1, adj + 1 + tot);
tot = unique(adj + 1, adj + 1 + tot) - adj - 1;
for (int i = 1; i <= m; i++) {
int u = get(e[i].u), v = get(e[i].v), w = e[i].w;
d[u][v][0] = d[v][u][0] = min(d[u][v][0], w);
}
s = get(s), t = get(t); for (int c = 1; c <= L; c++) {
for (int i = 1; i <= tot; i++) {
for (int j = 1; j <= tot; j++) {
for (int k = 1; k <= tot; k++) {
d[i][j][c] = min(d[i][j][c], d[i][k][c - 1] + d[k][j][c - 1]);
}
}
}
} memset(g, 0x3f, sizeof g);
g[s] = 0;
for (int c = 0; c <= L; c++) {
if(n >> c & 1) {
memset(f, 0x3f, sizeof f);
for (int i = 1; i <= tot; i++)
for (int j = 1; j <= tot; j++)
f[i] = min(f[i], g[j] + d[j][i][c]);
memcpy(g, f, sizeof g);
}
}
printf("%d\n", f[t]);
return 0;
}

AcWing 345. 牛站 Cow Relays的更多相关文章

  1. P2886 [USACO07NOV]牛继电器Cow Relays

    题目描述 For their physical fitness program, N (2 ≤ N ≤ 1,000,000) cows have decided to run a relay race ...

  2. [洛谷P2886] 牛继电器Cow Relays

    问题描述 For their physical fitness program, N (2 ≤ N ≤ 1,000,000) cows have decided to run a relay race ...

  3. [USACO07NOV]牛继电器Cow Relays

    题目描述 给出一张无向连通图,求S到E经过k条边的最短路. 输入输出样例 输入样例#1: 2 6 6 4 11 4 6 4 4 8 8 4 9 6 6 8 2 6 9 3 8 9 输出样例#1: 10 ...

  4. 洛谷P2886 [USACO07NOV]牛继电器Cow Relays

    题意很简单,给一张图,把基本的求起点到终点最短路改成求经过k条边的最短路. 求最短路常用的算法是dijkstra,SPFA,还有floyd. 考虑floyd的过程: c[i][j]=min(c[i][ ...

  5. Luogu 2886 [USACO07NOV]牛继电器Cow Relays

    BZOJ 1706权限题. 倍增$floyd$. 首先这道题有用的点最多只有$200$个,先离散化. 设$f_{p, i, j}$表示经过$2^p$条边从$i$到$j$的最短路,那么有转移$f_{p, ...

  6. [USACO07NOV]牛继电器Cow Relays (最短路,DP)

    题目链接 Solution 非正解 似乎比较蛇啊,先个一个部分分做法,最短路+\(DP\). 在求最短路的堆或者队列中存储元素 \(dis_{i,j}\) 代表 \(i\) 这个节点,走了 \(j\) ...

  7. 洛谷 [P2886] 牛继电器Cow Relays

    最短路 + 矩阵快速幂 我们可以改进矩阵快速幂,使得它适合本题 用图的邻接矩阵和快速幂实现 注意 dis[i][i] 不能置为 0 #include <iostream> #include ...

  8. [LUOGU] P2886 [USACO07NOV]牛继电器Cow Relays

    https://www.luogu.org/problemnew/show/P2886 给定无向连通图,求经过k条边,s到t的最短路 Floyd形式的矩阵乘法,同样满足结合律,所以可以进行快速幂. 离 ...

  9. [luoguP2886] [USACO07NOV]牛继电器Cow Relays(矩阵)

    传送门 矩阵快速幂,本质是floyd 把 * 改成 + 即可 注意初始化 因为只有100条边,所以可以离散化 #include <cstdio> #include <cstring& ...

随机推荐

  1. tcp syn-synack-ack 服务端接收ack

    TCP 服务端 接收到ack tcp_v4_rcv() -> tcp_v4_do_rcv() -> tcp_v4_hnd_req() + tcp_child_process()tcp_v4 ...

  2. 【java从入门到精通】day10-Java流程控制2-switch多选择结构

    1.switch多选择结构 switch case语句判断一个变量与一系列值中某个值是否相等,每个值称为一个分支. switch语句中的变量类型可以是: byte.short.int或者char 从j ...

  3. CephFS cache tier实践

    这是一篇分享文,作者因为最近想深入研究下ceph的cache pool,作者写的文章非常的好,这里先直接翻译这篇文章,然后再加入我自己的相关数据 blog原文 作者想启动blog写下自己的Openst ...

  4. oracle的迁移工作

    1.创建新数据库用户 1).创建用户和分配权限 sqlplus / as sysdba create user ENFRC_TEST_GZ_TMP identified by ENFRC_TEST_G ...

  5. Angualr 内置工具-SelectionModel

    SelectionModel: 被用来控制选中一个和多个item时候的逻辑.例如下拉菜单,复选框选中等,非常方便. 引入:import{SelectionModel}from'@angular/cdk ...

  6. Python _PyQt5对话框

    Python 调用PyQt5 制作对话框,退出时候有二次确认(注:默认是直接退出) 1 # -*- ytf-8 -*- 2 """ 3 用PyQt建一个对话框,退出时提示 ...

  7. SMTPAuthenticationError: (535, '5.7.8 authentication failed')解决办法

    代码: 运行之后一直报错,SMTPAuthenticationError: (535, '5.7.8 authentication failed'). 查找半天是因为新浪邮箱的STMP的服务没有开启, ...

  8. 链表(LinkedList)解题总结

    链表基础知识 定义 链表(Linked List)是一种常见的基础数据结构,是一种线性表,但是并不会按线性的顺序存储数据,而是在每一个节点里存到下一个节点的指针(Pointer). 链表的操作 操作 ...

  9. 5G时代,URL Rewrite 还吃香吗

    URL Rewrite是网站建设中经常用到的一项技巧,通过 rewrite 我们能够屏蔽服务器运行态的信息,包括服务的程序.参数等等,给用户呈现美化后的URL,同时对搜索引擎更加友好,方便我们网站的推 ...

  10. Guitar Pro教程之组织小节

    上一章节我们讲述了关于Guitar Pro 7的主界面的相关功能的介绍,对于初学作曲,又是吉他的初学者,刚刚接触{cms_selflink page='index' text='Guitar Pro' ...